// Generated by CoffeeScript 1.6.2
(function() {
  var Backbone, Factory, attributesFor, build, create, define, e, factories, shimmedModelFields, utils, _,
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; },
    __hasProp = {}.hasOwnProperty;

  _ = require('lodash');

  utils = require('./utils');

  try {
    Backbone = require('backbone');
  } catch (_error) {
    e = _error;
  }

  factories = {};

  shimmedModelFields = ['get', 'set'];

  define = function(name, model, options, attributes) {
    var associations, param, parent, parentAssoc, parentAttrs, _i, _len, _ref, _ref1, _ref2, _ref3, _ref4, _ref5, _ref6, _ref7, _ref8;

    switch (arguments.length) {
      case 1:
        options = name;
        _ref = [model, name];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          param = _ref[_i];
          param = void 0;
        }
        break;
      case 2:
        if ((model.attributes != null) || (model["extends"] != null) || (model.model != null)) {
          options = model;
          model = void 0;
        } else if (typeof model === 'function') {
          factories[name] = model;
          return true;
        }
        break;
      case 3:
        if ((model.attributes != null) || (model["extends"] != null) || (model.model != null)) {
          _ref1 = [model, options], options = _ref1[0], attributes = _ref1[1];
          model = void 0;
        }
        if (typeof model === 'function') {
          attributes = options;
          options = void 0;
        }
    }
    model = (_ref2 = options != null ? options.model : void 0) != null ? _ref2 : model;
    attributes = (_ref3 = (_ref4 = options != null ? options.attributes : void 0) != null ? _ref4 : attributes) != null ? _ref3 : {};
    name = (_ref5 = options != null ? options.name : void 0) != null ? _ref5 : name;
    associations = (_ref6 = options != null ? options.associations : void 0) != null ? _ref6 : {};
    if (options != null ? options["extends"] : void 0) {
      parent = factories[options["extends"]];
      if (model == null) {
        model = parent.model;
      }
      parentAttrs = _.clone((_ref7 = parent != null ? parent.attributes : void 0) != null ? _ref7 : {});
      _.defaults(attributes, parentAttrs);
      parentAssoc = _.clone((_ref8 = parent != null ? parent.associations : void 0) != null ? _ref8 : {});
      _.defaults(associations, parentAssoc);
    }
    return factories[name] = {
      model: model,
      attributes: attributes,
      associations: associations
    };
  };

  build = function(name, userAttrs, callback, noAssociations) {
    var associations, attributes, err, errorCb, factory, model, returnCb, setters, _ref, _ref1;

    if (noAssociations == null) {
      noAssociations = false;
    }
    if (typeof userAttrs === 'function') {
      _ref = [userAttrs, {}], callback = _ref[0], userAttrs = _ref[1];
    }
    factory = factories[name];
    if (typeof factory === 'function') {
      return factory(callback, userAttrs);
    }
    _ref1 = utils.flexCb(callback), returnCb = _ref1[0], errorCb = _ref1[1];
    if (factory == null) {
      err = new Error("factory-castrado cannot find factory: " + name);
      return errorCb(err);
    }
    model = factory.model;
    associations = _.clone(factory.associations);
    if (noAssociations) {
      associations = [];
    }
    attributes = _.clone(factory.attributes);
    _.extend(attributes, userAttrs);
    setters = [];
    return utils.asyncForEach(_.keys(associations), function(assocName, cb) {
      var assembledSetter, assoc, assocFactory, getterFn, key, setterFn, _obj, _ref2, _ref3, _ref4, _val;

      assoc = associations[assocName];
      assocFactory = factories[(_ref2 = assoc.factory) != null ? _ref2 : assocName];
      setterFn = assoc.setter;
      getterFn = (_ref3 = assoc.getter) != null ? _ref3 : function(obj) {
        return obj.id;
      };
      key = assoc.key;
      switch ((_ref4 = assoc.type) != null ? _ref4 : 'id') {
        case 'id':
          if (key == null) {
            key = assocName + '_id';
          }
          (function() {
            var _key;

            _key = key;
            return setterFn != null ? setterFn : setterFn = function(obj, val) {
              return obj.set(_key, val);
            };
          })();
          break;
        case 'ids[]':
          if (key == null) {
            key = assocName + '_ids';
          }
          (function() {
            var _key;

            _key = key;
            return setterFn != null ? setterFn : setterFn = function(obj, val) {
              var arrayField;

              arrayField = obj.get(_key);
              if (arrayField == null) {
                arrayField = [];
              }
              if (__indexOf.call(arrayField, val) < 0) {
                if (typeof arrayField.push === "function") {
                  arrayField.push(val);
                }
                return obj.set(key, arrayField);
              }
            };
          })();
      }
      if (attributes[assocName]) {
        _obj = associations[assocName] = attributes[assocName];
        delete attributes[assocName];
        _val = getterFn(_obj);
        assembledSetter = (function() {
          var val;

          val = _val;
          return (function(obj) {
            return setterFn(obj, _val);
          });
        })();
        setters.push(assembledSetter);
        return cb();
      } else if (attributes[key] && assoc.type === 'id') {
        return cb();
      } else {
        return create(assoc.factory, function(_obj) {
          var val;

          associations[assocName] = _obj;
          val = getterFn(_obj);
          assembledSetter = (function() {
            _val = val;
            return (function(obj) {
              return setterFn(obj, _val);
            });
          })();
          setters.push(assembledSetter);
          return cb();
        });
      }
    }, function() {
      return utils.asyncForEach(_.keys(attributes), function(key, cb) {
        var fn;

        fn = attributes[key];
        if (typeof fn === 'function' && __indexOf.call(shimmedModelFields, key) < 0) {
          return fn(function(computedVal) {
            attributes[key] = computedVal;
            return cb();
          });
        } else {
          return cb();
        }
      }, function() {
        var key, object, setter, val, _i, _len, _ref2, _ref3;

        object = new model(attributes);
        for (key in associations) {
          if (!__hasProp.call(associations, key)) continue;
          val = associations[key];
          object[key] = val;
        }
        if (object.get == null) {
          _.extend((_ref2 = object.prototype) != null ? _ref2 : object, {
            get: function(attr) {
              return this[attr];
            }
          });
        }
        if (object.set == null) {
          _.extend((_ref3 = object.prototype) != null ? _ref3 : object, {
            set: function(attr, val) {
              return this[attr] = val;
            }
          });
        }
        for (_i = 0, _len = setters.length; _i < _len; _i++) {
          setter = setters[_i];
          if (typeof setter === "function") {
            setter(object);
          }
        }
        for (key in attributes) {
          if (!__hasProp.call(attributes, key)) continue;
          val = attributes[key];
          object.set(key, val);
        }
        return returnCb(object);
      });
    });
  };

  create = function(name, userAttrs, callback) {
    var errorCb, returnCb, _ref, _ref1;

    if (typeof userAttrs === 'function') {
      _ref = [userAttrs, {}], callback = _ref[0], userAttrs = _ref[1];
    }
    if (typeof factories[name] === 'function') {
      return factories[name](callback, userAttrs);
    }
    _ref1 = utils.flexCb(callback), returnCb = _ref1[0], errorCb = _ref1[1];
    return build(name, userAttrs, function(err, doc) {
      if (err) {
        return errorCb(err);
      }
      if (typeof doc.create === "function") {
        doc.create(function(err, model) {
          if (err) {
            return errorCb(err);
          }
          return returnCb(doc);
        });
      }
      if (doc.create == null) {
        return returnCb(doc);
      }
    });
  };

  attributesFor = function(name, attrs, callback) {
    var errorCb, returnCb, _ref, _ref1;

    if (typeof attrs === 'function') {
      _ref = [attrs, {}], callback = _ref[0], attrs = _ref[1];
    }
    _ref1 = utils.flexCb(callback), returnCb = _ref1[0], errorCb = _ref1[1];
    return build(name, attrs, function(doc) {
      return returnCb((typeof doc.toJSON === "function" ? doc.toJSON() : void 0) || doc);
    }, "noAssociations");
  };

  Factory = create;

  Factory.define = define;

  Factory.build = build;

  Factory.create = create;

  Factory.attributesFor = attributesFor;

  module.exports = Factory;

}).call(this);
